kind: Model
api_version: v1beta1
metadata:
  display_name: Timestep initialiser
  name: timestep-initialiser
  publisher: CMCL Innovations
  summary: This is used by the CReDo digital twin to update the flood depth of the assets at each time step. Optionally launches the information cascade model to update the states of the assets.
  description: >
    This model is used within the CReDo timestep loop workflows to initialise new timesteps, pass flood data into the digital twin and launch the information cascade model if UPDATE_DERIVATIONS is set to true. The current timestep should be passed via the SIMULATION_TIMES parameter in the loop.
spec:
  inputs:
    parameters:
      - name: BLAZEGRAPH_HOST
        title: BLAZEGRAPH_HOST
        default: "blazegraph"
        description: "Host to use when contacting the blazegraph server."
        type: link
        required: true
      - name: BLAZEGRAPH_PORT
        title: BLAZEGRAPH_PORT
        default: 8080
        description: "Port to use when contacting the blazegraph server."
        type: integer
        required: false
      - name: ONTOP_HOST
        title: ONTOP_HOST
        default: "ontop"
        description: "Host url to use when contacting the ontop server."
        type: link
        required: true
      - name: ONTOP_PORT
        title: ONTOP_PORT
        default: 8080
        description: "Port to use when contacting the ontop server."
        type: integer
        required: false
      - name: POSTGRES_HOST
        title: POSTGRES_HOST
        default: "postgis"
        description: "Host url to use when contacting the postgres server."
        type: link
        required: true
      - name: POSTGRES_PASSWORD
        title: POSTGRES_PASSWORD
        default: "postpass"
        description: "Password to use when contacting the postgres server."
        type: string
        required: true
      - name: POSTGRES_PORT
        title: POSTGRES_PORT
        default: 5432
        description: "Port to use when contacting the postgres server."
        type: integer
        required: false
      - name: POSTGRES_USER
        title: POSTGRES_USER
        default: "postgres"
        description: "Username to use when contacting the postgres server."
        type: string
        required: false
      - name: SIMULATION_TIMES
        title: SIMULATION_TIMES
        default: ""
        description: "A list of simulation timesteps. Only required when using this model in 'timestep-initialiser' mode."
        type: integer
        required: false
      - name: UPDATE_DERIVATIONS
        title: UPDATE_DERIVATIONS
        default: "true"
        description: "Trigger update derivations if set to true"
        type: string
        required: false
